'-- uni8ad_fb-mw.bas ------------------------------------------- >>fst'12<< -
' - liest den Universal 8-Bit AD Wandler per "Bitbanging" aus
' - ermittelt mehrere Messwerte und bildet einen Mittelwert
' - nutzt WinAPI zur Ansteuerung der seriellen Schnittstelle
'   sollte deshalb auch mit USB-seriell Adaptern funktionieren
' - Compiler: FreeBasic 
' - Verbindungen: (Bauanleitung im Internet; s.u.)
'   - TLC549 -       - COM -  - Zweck ---------------------------
'   VCC         <-     TxD    Versorgungsspannung fuer Platine
'   I/O Clock   <-     DTR    Taktleitung
'   DATA OUT    ->     CTS    Daten vom Wandler
'   CS          <-     RTS    Wandler-Aktivierung (Chip-Select)
'-- V 20120318 ------------------------------- http://www.FrankSteinberg.de -

#INCLUDE ONCE "windows.bi"

Dim Ref As Single  = .256      'hier am uni8ad eingestellte Referenzspannung angeben
Dim hCom As handle             'Handle des Comports
Dim modemStat As dword         'Rckgabewert der Eingangsleitungen
Dim PortNr As String = "COM1"  'oder COM2 , COM3 usw.
Dim SWert As Integer           'Aufsummierte Messwerte (zur Mittelwertbildung)
Dim EW As UByte                'einzelner Messwert
Dim BitWert As UByte           'Wertigkeit des aktuell ausgelesenen Bits 
Dim As Integer WMin, WMax      'minimaler / maximaler Messwert pro Durchgang
Dim U As Single                'Messwert als Spannung
Dim As Integer i, j            'Zhlvariablen
Dim TStart As Double           'Timer Startzeit fr Zeitmessung


'Serielle Schnittstelle ffnen:
hCom = CreateFile("//./"+PortNr, GENERIC_READ Or GENERIC_WRITE, 0, NULL, OPEN_EXISTING, 0, NULL)
'Fehlerbehandlung, falls ffnen fehlschlgt:
If hCom = INVALID_HANDLE_VALUE Then
  MessageBox 0,"Fehler beim ffnen von " & PortNr,"Fehler:", MB_ICONERROR
  End
End If

'Steuerleitungen low:
EscapeCommFunction(hCom, CLRRTS)    'RTS -12V
EscapeCommFunction(hCom, CLRDTR)    'DTR -12V

'Stromversorgung des Wandlers an TxD -> VSS ein
EscapeCommFunction(hCom, SETBREAK)
 
PRINT
PRINT "Universal 8-Bit AD-Wandler    >>fst'12<<"
Print " - Ende mit [Esc] -"
Print
PRINT "Schnittstelle    = "; PortNr
Print "Referenzspannung ="; Ref; "Volt"

DO                                          'Beginn der Hauptschleife
 
  SWert = 0                                 'alten Summenwert loeschen
  EscapeCommFunction(hCom, SETRTS)          'RTS +12V  CS high
  Sleep(1)                                  'kurz warten
  EscapeCommFunction(hCom, CLRRTS)          'RTS -12V  CS low
  Sleep(1)                                  'kurz warten

  TStart = Timer                            'Startzeit des Messzyklus festhalten
  i = 0                                     '
  
  Do                                        'mehrere Werte lesen (Dauer 1 Sek.)
   EscapeCommFunction(hCom, SETRTS)         'RTS +12V  CS high
   Sleep(0)
   BitWert = 128                            'Erstet Bit hat den Wert 128 (MSB)
   EscapeCommFunction(hCom, CLRRTS)         'RTS -12V  CS low
   Sleep(1)
   EW = 0                                   'Messwert auf Null
   Do                                       'Schleife fr Einzelwert
    GetCommModemStatus(hCom, @modemStat)    'Zustand von CTS (=DATA OUT) lesen
    EscapeCommFunction(hCom, SETDTR)        'DTR +12V  CLK high
    Sleep(0)
    IF (modemStat And MS_CTS_ON) THEN EW = EW + BitWert  'Bitwert zum Byte aufaddieren
    EscapeCommFunction(hCom, CLRDTR)        'DTR -12V  CLK low
    Sleep(0)
    Bitwert = Bitwert \ 2                   'nchstes Bit hat halbe Wertigkeit
   Loop While BitWert                       'Ende Einzelwertmessung, wenn Bitwert = 0
   SWert = SWert + EW                       'Summe fuer Mittelwert bilden
   IF EW < WMin THEN WMin = EW              'Minimalwert speichern
   IF EW > WMax THEN WMax = EW              'Maximalwert speichern
   i = i + 1                                'Anzahl der Einzelwerte zhlen   
  Loop Until (Timer - TStart) >= 1          'Ende nach 1 Sekunde

  'Werte anzeigen
  LOCATE 10
  PRINT USING "Messungen/Sek. #########"; i
  Print
  Print USING "Minimalwert  ###  Digits"; WMin
  PRINT USING "Maximalwert  ###  Digits"; WMax
  PRINT USING "Streuung     ###  Digits"; WMax - WMin + 1
  SWert = SWert / i                       'Mittelwert bilden
  Print USING "Mittelwert   ###  Digits"; SWert
  U = SWert * Ref / 256                     'Messspannung berechnen
  PRINT
  PRINT USING "Spannung   #.###  Volt "; U
 
  WMin = 333                                'alten Minimalwert loeschen
  WMax = 0                                  'alten Maximalwert loeschen
  SWert = 0                                 'alten Summenwert loeschen
 
Loop WHILE INKEY$ = ""                      'Ende bei Tastendruck

'Serielle Schnittstelle schlieen:
closeHandle(hCom)
